###################################################
### chunk number 1: preliminaries
###################################################
#line 19 "/build/buildd/lmtest-0.9.27/inst/doc/lmtest-intro.Rnw"
library(lmtest)
options(SweaveHooks=list(twofig=function() {par(mfrow=c(1,2))},
                         twofig2=function() {par(mfrow=c(2,1))},
                         onefig=function() {par(mfrow=c(1,1))}))


###################################################
### chunk number 2: macro-jocci
###################################################
#line 107 "/build/buildd/lmtest-0.9.27/inst/doc/lmtest-intro.Rnw"
data(jocci)
plot(jocci[,"dy"], ylab = "jocci (log first differences)")
ar6.model <- dy ~ dy1 + dy2 + dy3 + dy4 + dy5 +dy6
jocci.fm <- lm(ar6.model, data = jocci)
plot(time(jocci), residuals(jocci.fm), xlab = "Time", ylab = "AR(6) residuals")


###################################################
### chunk number 3: macro-corr1
###################################################
#line 120 "/build/buildd/lmtest-0.9.27/inst/doc/lmtest-intro.Rnw"
data(jocci)
dwtest(dy ~ 1, data = jocci)


###################################################
### chunk number 4: macro-model
###################################################
#line 127 "/build/buildd/lmtest-0.9.27/inst/doc/lmtest-intro.Rnw"
ar6.model <- dy ~ dy1 + dy2 + dy3 + dy4 + dy5 +dy6


###################################################
### chunk number 5: macro-corr2
###################################################
#line 132 "/build/buildd/lmtest-0.9.27/inst/doc/lmtest-intro.Rnw"
bgtest(ar6.model, data = jocci)


###################################################
### chunk number 6: macro-hetsked1
###################################################
#line 144 "/build/buildd/lmtest-0.9.27/inst/doc/lmtest-intro.Rnw"
var.model <- ~ I(dy1^2) + I(dy2^2) + I(dy3^2) + I(dy4^2) + I(dy5^2) + I(dy6^2)
bptest(ar6.model, var.model, data = jocci)


###################################################
### chunk number 7: mandible-data
###################################################
#line 174 "/build/buildd/lmtest-0.9.27/inst/doc/lmtest-intro.Rnw"
data(Mandible)
mandible <- log(Mandible)
attach(mandible)
plot(mandible)
fm <- lm(length ~ age)
fm2 <- lm(length ~ age + I(age^2))
lines(age, fitted(fm), col = 2)
lines(age, fitted(fm2), col = 4)


###################################################
### chunk number 8: mandible-res
###################################################
#line 196 "/build/buildd/lmtest-0.9.27/inst/doc/lmtest-intro.Rnw"
plot(age, residuals(fm), ylab = "residuals (linear model)")
plot(age, residuals(fm2), ylab = "residuals (quadratic model)")
detach(mandible)


###################################################
### chunk number 9: mandible-tests1 eval=FALSE
###################################################
## #line 211 "/build/buildd/lmtest-0.9.27/inst/doc/lmtest-intro.Rnw"
## data(Mandible)
## mandible <- log(Mandible)
## harvtest(length ~ age, order.by = ~ age, data = mandible)
## raintest(length ~ age, order.by = ~ age, data = mandible)


###################################################
### chunk number 10: mandible-tests2
###################################################
#line 222 "/build/buildd/lmtest-0.9.27/inst/doc/lmtest-intro.Rnw"
resettest(length ~ age, data = mandible)


###################################################
### chunk number 11: mandible-tests3
###################################################
#line 227 "/build/buildd/lmtest-0.9.27/inst/doc/lmtest-intro.Rnw"
resettest(length ~ age, power = 2, type = "regressor", data = mandible)


###################################################
### chunk number 12: mandible-tests4
###################################################
#line 238 "/build/buildd/lmtest-0.9.27/inst/doc/lmtest-intro.Rnw"
raintest(length ~ age + I(age^2), order.by = ~ age, data = mandible)


###################################################
### chunk number 13: mandible-supF
###################################################
#line 241 "/build/buildd/lmtest-0.9.27/inst/doc/lmtest-intro.Rnw"
if(require(strucchange)) {
  supF.pval <- round(sctest(length ~ age + I(age^2), data = mandible, to = 0.9, type = "supF")$p.value, digits = 3)
} else {
#  warning("`strucchange' not available: p value set to NA")
  supF.pval <- NA
}


